# CSC 249 HW4 web server: WebServer.py
#
# Author: J Cardell
# Date: Oct 2012
#
# To use this web server
#  1) put an html file in the same directory
#  2) start your web server process running
#  3) open any web browser (client) and enter 
#     http://your_IPaddress:your_serverPort/your_HTML_filename.html
#
#     At this point, your HTML file should be displayed in your web browser.
#

# Import socket module
from socket import *    

# Create a TCP server socket
#  (AF_INET is used for IPv4 protocols)
#  (SOCK_STREAM is used for TCP)
serverSocket = socket(AF_INET, SOCK_STREAM)
serverHost = 'localhost'
recvBuffer = 1024

# Assign a port number. Since this is not actually working over the network, and since the Smith
# system itself does already use port 80 for the webserver, it makes sense to use a different
# port number (1024 <= your_port <= 65535
serverPort = 1602

# Bind the socket to server address and server port
serverSocket.bind((serverHost, serverPort))

# Listen to at most 1 connection at a time
serverSocket.listen(1)

# Server must be running and listening for incoming connections before the client connects
while True:
	print 'Test WebServer is running...'
	
	# Accept the connection request and set up a new connection for the client
	connectionSocket, addr = serverSocket.accept()

        # ** NOTE that instead of using the 'try: ... except:...' structure, you can use
        # the os library, and check if the file exists using
        #   if os.path.exists(filename):...
        # Then only if the file is in the current directory do you continue to open & send it.

	
	# If an exception (error) occurs during the execution of the try clause, the
	# 'try' section is skipped. If the exception type matches the word after the 
	# 'except,' then the except clause is executed
	try:
		# Receive the request message from the client
		message =  connectionSocket.recv(recvBuffer)
		# Extract the path of the requested file from the message
		# The path is the second part of HTTP header, identified by [1]
		filename = message.split()[1]
		# The extracted path of the HTTP request includes a '\'
		# character, so process the path from the second character 
		f = open(filename[1:])
		# Store the  contents of the requested file in a variable
		filedata = f.read()
		# Send the HTTP response header line to the connection socket
		connectionSocket.send("HTTP/1.1 200 OK\r\n\r\n")
 
		# Send the content of the requested file to the connection socket
		for i in range(0, len(filedata)):  
			connectionSocket.send(filedata[i])
		connectionSocket.send("\r\n")
		
		# Close the client connection socket
		connectionSocket.close()

	except IOError:
		# Send HTTP response message for file not found
		connectionSocket.send("HTTP/1.1 404 Not Found\r\n\r\n")
		connectionSocket.send("<html><head></head><body><h1>404 Not Found</h1></body></html>\r\n")
		# Close the client connection socket
		connectionSocket.close()

serverSocket.close()  

